Package net.sf.saxon.tree.wrapper

## Class VirtualCopy.VirtualCopier

- java.lang.Object
- - net.sf.saxon.tree.wrapper.VirtualCopy.VirtualCopier

- All Implemented Interfaces:
    `java.io.Closeable`, `java.lang.AutoCloseable`, `SequenceIterator`, `AxisIterator`, `UnfailingIterator`
  Enclosing class:
    VirtualCopy

      protected class VirtualCopy.VirtualCopier
      extends java.lang.Object
      implements AxisIterator

  VirtualCopier implements the XPath axes as applied to a VirtualCopy node. It works by applying the requested axis to the node of which this is a copy. There are two complications: firstly, all nodes encountered must themselves be (virtually) copied to give them a new identity. Secondly, axes that stray outside the subtree rooted at the original copied node must be truncated.

- - ### Nested Class Summary

    - ### Nested classes/interfaces inherited from interface net.sf.saxon.om.SequenceIterator

      `SequenceIterator.Property`

  - ### Field Summary

    Fields
    Modifier and Type | Field | Description
    --- | --- | ---
    `protected AxisIterator` | `base` |
    `protected boolean` | `testInclusion` |

  - ### Constructor Summary

    Constructors
    Constructor | Description
    --- | ---
    `VirtualCopier​(AxisIterator base, VirtualCopy parent, boolean testInclusion)` |

  - ### Method Summary

    All Methods Instance Methods Concrete Methods
    Modifier and Type | Method | Description
    --- | --- | ---
    `void` | `close()` | Close the iterator.
    `NodeInfo` | `next()` | Get the next item in the sequence.

    - ### Methods inherited from class java.lang.Object

      `clone, equals, finalize, getClass, hashCode, notify, notifyAll, toString, wait, wait, wait`

    - ### Methods inherited from interface net.sf.saxon.tree.iter.AxisIterator

      `asIterator, forEachNode`

    - ### Methods inherited from interface net.sf.saxon.om.SequenceIterator

      `forEachOrFail, getProperties, materialize`

    - ### Methods inherited from interface net.sf.saxon.tree.iter.UnfailingIterator

      `forEach, toList`

- - ### Field Detail

    - #### base

          protected AxisIterator base

    - #### testInclusion

          protected boolean testInclusion

  - ### Constructor Detail

    - #### VirtualCopier

          public VirtualCopier​(AxisIterator base,
                               VirtualCopy parent,
                               boolean testInclusion)

  - ### Method Detail

    - #### next

          public NodeInfo next()

      Get the next item in the sequence.
      Specified by:
        `next` in interface `AxisIterator`
      Specified by:
        `next` in interface `SequenceIterator`
      Specified by:
        `next` in interface `UnfailingIterator`
      Returns:
        the next Item. If there are no more nodes, return null.

    - #### close

          public void close()

      Description copied from interface: `SequenceIterator`
      Close the iterator. This indicates to the supplier of the data that the client does not require any more items to be delivered by the iterator. This may enable the supplier to release resources. After calling close(), no further calls on the iterator should be made; if further calls are made, the effect of such calls is undefined.

      For example, the iterator returned by the unparsed-text-lines() function has a close() method that causes the underlying input stream to be closed, whether or not the file has been read to completion.

      Closing an iterator is important when the data is being "pushed" in another thread. Closing the iterator terminates that thread and means that it needs to do no additional work. Indeed, failing to close the iterator may cause the push thread to hang waiting for the buffer to be emptied.

      Specified by:
        `close` in interface `java.lang.AutoCloseable`
      Specified by:
        `close` in interface `java.io.Closeable`
      Specified by:
        `close` in interface `SequenceIterator`